import logic.MODE
import logic.parsing_sites.BNBSite
import org.junit.jupiter.api.AfterEach
import org.junit.jupiter.api.Assertions.assertEquals
import org.junit.jupiter.api.BeforeEach
import org.junit.jupiter.api.DisplayName
import org.junit.jupiter.api.Test
import java.lang.StringBuilder

@DisplayName("BNB site page")
class BNBSiteTest: BankSiteTest() {

    val outputAll = """ExchangeOffice(name=Центр банковских услуг №3 (БЦ «Терминал»), address=Минск ул. В. Хоружей 25/3, (Бизнес-центр «Терминал»), currencies=[CurrencyCourse(type=USD, purchase=2.122, selling=2.13), CurrencyCourse(type=EUR, purchase=2.385, selling=2.399), CurrencyCourse(type=RUB_100, purchase=3.27, selling=3.295), CurrencyCourse(type=EUR_USD, purchase=1.115, selling=1.135), CurrencyCourse(type=USD_RUB, purchase=64.0, selling=65.5), CurrencyCourse(type=EUR_RUB, purchase=72.0, selling=73.6)])
ExchangeOffice(name=Центр банковских услуг №4, address=Минск, пр-т Независимости, 87а (площадь Калинина), currencies=[CurrencyCourse(type=USD, purchase=2.122, selling=2.13), CurrencyCourse(type=EUR, purchase=2.385, selling=2.399), CurrencyCourse(type=RUB_100, purchase=3.27, selling=3.295), CurrencyCourse(type=GBP, purchase=2.6, selling=2.795), CurrencyCourse(type=PLN_10, purchase=5.0, selling=5.575), CurrencyCourse(type=EUR_USD, purchase=1.115, selling=1.135), CurrencyCourse(type=USD_RUB, purchase=64.0, selling=65.5), CurrencyCourse(type=EUR_RUB, purchase=72.0, selling=73.6)])
ExchangeOffice(name=Центр банковских услуг №5, address=Минск, ул. М.Танка, 1а, currencies=[CurrencyCourse(type=USD, purchase=2.122, selling=2.13), CurrencyCourse(type=EUR, purchase=2.385, selling=2.399), CurrencyCourse(type=RUB_100, purchase=3.27, selling=3.295), CurrencyCourse(type=EUR_USD, purchase=1.115, selling=1.135), CurrencyCourse(type=USD_RUB, purchase=64.0, selling=65.5), CurrencyCourse(type=EUR_RUB, purchase=72.0, selling=73.6)])
ExchangeOffice(name=Центр банковских услуг №6, address=Минск, пр-т Независимости, 37, currencies=[CurrencyCourse(type=USD, purchase=2.122, selling=2.13), CurrencyCourse(type=EUR, purchase=2.385, selling=2.399), CurrencyCourse(type=RUB_100, purchase=3.27, selling=3.295), CurrencyCourse(type=EUR_USD, purchase=1.115, selling=1.135), CurrencyCourse(type=USD_RUB, purchase=64.0, selling=65.5), CurrencyCourse(type=EUR_RUB, purchase=72.0, selling=73.6)])
ExchangeOffice(name=Центр банковских услуг №7, address=Минск, пр-т Независимости, 168/3, currencies=[CurrencyCourse(type=USD, purchase=2.122, selling=2.13), CurrencyCourse(type=EUR, purchase=2.385, selling=2.399), CurrencyCourse(type=RUB_100, purchase=3.27, selling=3.295), CurrencyCourse(type=EUR_USD, purchase=1.115, selling=1.135), CurrencyCourse(type=USD_RUB, purchase=64.0, selling=65.5), CurrencyCourse(type=EUR_RUB, purchase=72.0, selling=73.6)])
ExchangeOffice(name=Центр банковских услуг №8, address=Минск, ул. Бельского, 2, currencies=[CurrencyCourse(type=USD, purchase=2.09, selling=2.16), CurrencyCourse(type=EUR, purchase=2.35, selling=2.42), CurrencyCourse(type=RUB_100, purchase=3.0, selling=3.4), CurrencyCourse(type=EUR_USD, purchase=1.1, selling=1.15), CurrencyCourse(type=USD_RUB, purchase=63.0, selling=67.0), CurrencyCourse(type=EUR_RUB, purchase=70.0, selling=76.0)])
ExchangeOffice(name=Центр банковских услуг №10 (ТЦ «Метрополь»), address=Минск, ул. Немига, 5, currencies=[CurrencyCourse(type=USD, purchase=2.12, selling=2.135), CurrencyCourse(type=EUR, purchase=2.38, selling=2.399), CurrencyCourse(type=RUB_100, purchase=3.26, selling=3.3), CurrencyCourse(type=EUR_USD, purchase=1.11, selling=1.14), CurrencyCourse(type=USD_RUB, purchase=63.5, selling=66.0), CurrencyCourse(type=EUR_RUB, purchase=71.5, selling=74.1)])
ExchangeOffice(name=Центр банковских услуг №11 (ТЦ «Замок»), address=Минск, пр-т Победителей, 65 (ТЦ «Замок»), currencies=[CurrencyCourse(type=USD, purchase=2.122, selling=2.13), CurrencyCourse(type=EUR, purchase=2.385, selling=2.399), CurrencyCourse(type=RUB_100, purchase=3.27, selling=3.295), CurrencyCourse(type=GBP, purchase=2.6, selling=2.795), CurrencyCourse(type=PLN_10, purchase=5.0, selling=5.575), CurrencyCourse(type=EUR_USD, purchase=1.115, selling=1.135), CurrencyCourse(type=USD_RUB, purchase=64.0, selling=65.5), CurrencyCourse(type=EUR_RUB, purchase=72.0, selling=73.6)])
ExchangeOffice(name=Центр банковских услуг №17 (ТЦ «Титан»), address=Минск, пр-т Дзержинского, 104 (ТЦ «Титан»), currencies=[CurrencyCourse(type=USD, purchase=2.12, selling=2.134), CurrencyCourse(type=EUR, purchase=2.375, selling=2.399), CurrencyCourse(type=RUB_100, purchase=3.25, selling=3.3), CurrencyCourse(type=EUR_USD, purchase=1.11, selling=1.14), CurrencyCourse(type=USD_RUB, purchase=63.5, selling=66.0), CurrencyCourse(type=EUR_RUB, purchase=71.5, selling=74.1)])
ExchangeOffice(name=Центр банковских услуг №9 в Гомеле, address=Гомель, пр-т Октября, 27, currencies=[CurrencyCourse(type=USD, purchase=2.122, selling=2.13), CurrencyCourse(type=EUR, purchase=2.385, selling=2.399), CurrencyCourse(type=RUB_100, purchase=3.27, selling=3.295), CurrencyCourse(type=EUR_USD, purchase=1.115, selling=1.135), CurrencyCourse(type=USD_RUB, purchase=64.0, selling=65.5), CurrencyCourse(type=EUR_RUB, purchase=72.0, selling=73.6)])
ExchangeOffice(name=Центр банковских услуг №18 в Гродно, address=Гродно, ул. Социалистическая, 44, currencies=[CurrencyCourse(type=USD, purchase=2.122, selling=2.13), CurrencyCourse(type=EUR, purchase=2.385, selling=2.399), CurrencyCourse(type=RUB_100, purchase=3.27, selling=3.295), CurrencyCourse(type=GBP, purchase=2.6, selling=2.795), CurrencyCourse(type=PLN_10, purchase=5.0, selling=5.575), CurrencyCourse(type=EUR_USD, purchase=1.115, selling=1.135), CurrencyCourse(type=USD_RUB, purchase=64.0, selling=65.5), CurrencyCourse(type=EUR_RUB, purchase=72.0, selling=73.6)])
ExchangeOffice(name=Центр банковских услуг №14 в Могилеве, address=Могилев, ул. Ленинская, 56/6, currencies=[CurrencyCourse(type=USD, purchase=2.122, selling=2.13), CurrencyCourse(type=EUR, purchase=2.385, selling=2.399), CurrencyCourse(type=RUB_100, purchase=3.27, selling=3.295), CurrencyCourse(type=EUR_USD, purchase=1.115, selling=1.135), CurrencyCourse(type=USD_RUB, purchase=64.0, selling=65.5), CurrencyCourse(type=EUR_RUB, purchase=72.0, selling=73.6)])
ExchangeOffice(name=Центр банковских услуг №2 в Витебске, address=Витебск, ул. Толстого, 4 (площадь Свободы, Ратуша), currencies=[CurrencyCourse(type=USD, purchase=2.122, selling=2.13), CurrencyCourse(type=EUR, purchase=2.385, selling=2.399), CurrencyCourse(type=RUB_100, purchase=3.27, selling=3.295), CurrencyCourse(type=EUR_USD, purchase=1.115, selling=1.135), CurrencyCourse(type=USD_RUB, purchase=64.0, selling=65.5), CurrencyCourse(type=EUR_RUB, purchase=72.0, selling=73.6)])
ExchangeOffice(name=Пункт обмена валют №1 (Гипермаркет «Корона»), address=Минск, ул. Корженевского, 26, currencies=[CurrencyCourse(type=USD, purchase=2.09, selling=2.16), CurrencyCourse(type=EUR, purchase=2.35, selling=2.42), CurrencyCourse(type=RUB_100, purchase=3.0, selling=3.4), CurrencyCourse(type=EUR_USD, purchase=1.1, selling=1.15), CurrencyCourse(type=USD_RUB, purchase=63.0, selling=67.0), CurrencyCourse(type=EUR_RUB, purchase=70.0, selling=76.0)])
ExchangeOffice(name=Пункт обмена валют №2 (ТЦ «Перекресток»), address=г. Могилев, ул. Космонавтов, 2, currencies=[CurrencyCourse(type=USD, purchase=2.12, selling=2.131), CurrencyCourse(type=EUR, purchase=2.38, selling=2.399), CurrencyCourse(type=RUB_100, purchase=3.26, selling=3.289), CurrencyCourse(type=EUR_USD, purchase=1.105, selling=1.145), CurrencyCourse(type=USD_RUB, purchase=63.2, selling=66.3), CurrencyCourse(type=EUR_RUB, purchase=71.2, selling=74.4)])
ExchangeOffice(name=Пункт обмена валют №3 (ТЦ «Maximus»), address=Минск, ул. Есенина, 76, currencies=[CurrencyCourse(type=USD, purchase=2.09, selling=2.16), CurrencyCourse(type=EUR, purchase=2.35, selling=2.42), CurrencyCourse(type=RUB_100, purchase=3.0, selling=3.4), CurrencyCourse(type=EUR_USD, purchase=1.1, selling=1.15), CurrencyCourse(type=USD_RUB, purchase=63.0, selling=67.0), CurrencyCourse(type=EUR_RUB, purchase=70.0, selling=76.0)])
ExchangeOffice(name=Пункт обмена валют №4 (ТЦ «Новая Европа», первый этаж), address=Минск, ул. Сурганова, 57Б, currencies=[CurrencyCourse(type=USD, purchase=2.09, selling=2.16), CurrencyCourse(type=EUR, purchase=2.35, selling=2.42), CurrencyCourse(type=RUB_100, purchase=3.0, selling=3.4), CurrencyCourse(type=EUR_USD, purchase=1.1, selling=1.15), CurrencyCourse(type=USD_RUB, purchase=63.0, selling=67.0), CurrencyCourse(type=EUR_RUB, purchase=70.0, selling=76.0)])
ExchangeOffice(name=Пункт обмена валют №5 (ТЦ «Новая Европа», цокольный этаж), address=Минск, ул. Сурганова, 57Б, currencies=[CurrencyCourse(type=USD, purchase=2.09, selling=2.16), CurrencyCourse(type=EUR, purchase=2.35, selling=2.42), CurrencyCourse(type=RUB_100, purchase=3.0, selling=3.4), CurrencyCourse(type=EUR_USD, purchase=1.1, selling=1.15), CurrencyCourse(type=USD_RUB, purchase=63.0, selling=67.0), CurrencyCourse(type=EUR_RUB, purchase=70.0, selling=76.0)])
ExchangeOffice(name=Пункт обмена валют №6 (ТЦ «Секрет»), address=г. Гомель, ул. Гагарина, 65, currencies=[CurrencyCourse(type=USD, purchase=2.11, selling=2.136), CurrencyCourse(type=EUR, purchase=2.37, selling=2.4), CurrencyCourse(type=RUB_100, purchase=3.2, selling=3.3), CurrencyCourse(type=EUR_USD, purchase=1.105, selling=1.145), CurrencyCourse(type=USD_RUB, purchase=63.2, selling=66.3), CurrencyCourse(type=EUR_RUB, purchase=71.2, selling=74.4)])
ExchangeOffice(name=Пункт обмена валют №7 (ТРЦ «Galleria Minsk»), address=Минск, пр-т Победителей, 9 (1-й этаж), currencies=[CurrencyCourse(type=USD, purchase=2.12, selling=2.13), CurrencyCourse(type=EUR, purchase=2.38, selling=2.399), CurrencyCourse(type=RUB_100, purchase=3.27, selling=3.295), CurrencyCourse(type=EUR_USD, purchase=1.105, selling=1.145), CurrencyCourse(type=USD_RUB, purchase=63.2, selling=66.3), CurrencyCourse(type=EUR_RUB, purchase=71.2, selling=74.4)])
ExchangeOffice(name=Пункт обмена валют №11 (супермаркет «Евроопт»), address=Минск, ул. Ротмистрова, 42, currencies=[CurrencyCourse(type=USD, purchase=2.09, selling=2.16), CurrencyCourse(type=EUR, purchase=2.35, selling=2.42), CurrencyCourse(type=RUB_100, purchase=3.0, selling=3.4), CurrencyCourse(type=EUR_USD, purchase=1.1, selling=1.15), CurrencyCourse(type=USD_RUB, purchase=63.0, selling=67.0), CurrencyCourse(type=EUR_RUB, purchase=70.0, selling=76.0)])
ExchangeOffice(name=Пункт обмена валют №13 (Гипердискаунтер «Евроопт»), address=Минск, 31 км МКАД (Минский р-н, Щомыслинский с.с.п / у Западный, ТЭЦ-4); ул. Монтажников, 2, currencies=[CurrencyCourse(type=USD, purchase=2.12, selling=2.132), CurrencyCourse(type=EUR, purchase=2.375, selling=2.399), CurrencyCourse(type=RUB_100, purchase=3.24, selling=3.3), CurrencyCourse(type=EUR_USD, purchase=1.105, selling=1.145), CurrencyCourse(type=USD_RUB, purchase=63.2, selling=66.3), CurrencyCourse(type=EUR_RUB, purchase=71.2, selling=74.4)])
ExchangeOffice(name=Пункт обмена валют №15 (ТЦ «Корона»), address=Витебск, Бешенковичское шоссе, 3-1, currencies=[CurrencyCourse(type=USD, purchase=2.122, selling=2.131), CurrencyCourse(type=EUR, purchase=2.382, selling=2.399), CurrencyCourse(type=RUB_100, purchase=3.265, selling=3.295), CurrencyCourse(type=EUR_USD, purchase=1.105, selling=1.145), CurrencyCourse(type=USD_RUB, purchase=63.2, selling=66.3), CurrencyCourse(type=EUR_RUB, purchase=71.2, selling=74.4)])
ExchangeOffice(name=Центр банковских услуг №12 в Бресте, address=Брест, ул. Маяковского, 17, корп.2, currencies=[CurrencyCourse(type=USD, purchase=2.122, selling=2.13), CurrencyCourse(type=EUR, purchase=2.385, selling=2.399), CurrencyCourse(type=RUB_100, purchase=3.27, selling=3.295), CurrencyCourse(type=GBP, purchase=2.6, selling=2.795), CurrencyCourse(type=PLN_10, purchase=5.0, selling=5.575), CurrencyCourse(type=EUR_USD, purchase=1.115, selling=1.135), CurrencyCourse(type=USD_RUB, purchase=64.0, selling=65.5), CurrencyCourse(type=EUR_RUB, purchase=72.0, selling=73.6)])

    """.trimIndent()

    @BeforeEach
    fun setTestMode(){
        MODE = "TEST"
    }

    @AfterEach
    fun setDevMode() {
        MODE = "DEV"
    }

    @Test
    @DisplayName("should parse all exchange offices on page")
    fun parseAll() {
        val sb = StringBuilder()
        BNBSite().loadAllExchangeData {
            sb.append(it.toString()).append("\n")
            //println(it)
        }
        assertEquals(outputAll, sb.toString(), "Parse data is not correct")
        //println(sb)
    }
}